	package cs214.dispatch;


	abstract class Base {
	    public void foo() {
			bar();
			baz();
		}

	    private void doBar() {    	
			System.out.println("bar");
	    }
	    
		public void bar() {
			doBar();
		}
		public void baz() {
			System.out.println("baz");
		}
		public void meet(Base other) {
			other.bar();
		}
	}

	class Derived extends Base {
	    public void foo() {
			super.foo();
			System.out.println("Derived");		
		}
		@Override
		public void bar() {
			System.out.println("bam!");
		}
		public void baz(int i) {
			System.out.println("i = " + i);
		}
		public void biff() {
			System.out.println("biff");
		}
		public void meet(Derived other) {
			System.out.println("yowsers!");
		}
	}


	public class Client {
		
		/** QUESTION: what does test1 print?
		 * Or, are there compile or run-time error(s)?
		 */
		public static void test1(Base b) {
			b.foo();
		}
		
		/** QUESTION: what does test2 print?
		 * Or, are there compile or run-time error(s)?
		 */
		/*public static void test2(Base b1, Base b2) {
			b1.meet(b2);
		}*/
		
		/** QUESTION: what does test3 print?
		 * Or, are there compile or run-time error(s)?
		 */
		/*public static void test3() {
			Base b = new Base();
			b.biff();
			Derived d = b;
		}*/
		
		public static void main(String args[]) {
			Base b1 = new Derived();
			Base b2 = new Derived();
			test1(b1);
			//test2(b1, b2);
			//test3();
		}
	}

